unit Config;

interface

type
  TConfig = record
    FirstWDay: Integer;
    FontBold: Boolean;
    FontItalic: Boolean;
    FontName: string;
    OuterDays: Boolean;
    WeekNumber: Boolean;
    YearDay: Boolean;
  end;

procedure LoadConfig(const Path: string; var Conf: TConfig);

implementation

uses NLib, NConf;

procedure LoadConfig(const Path: string; var Conf: TConfig);
var
  s: string;
  i: Integer;
begin
  Conf.FontName := 'Arial';
  Conf.FirstWDay := 6;
  try
    with TConf.Create(Path) do
      try
        while ReadLine do
        begin
          s := GetArg(0);
          if s = 'font' then
          begin
            Conf.FontName := GetArg(1);
            for i := 2 to 3 do
            begin
              Conf.FontBold := Conf.FontBold or (GetArg(i) = 'bold');
              Conf.FontItalic := Conf.FontItalic or (GetArg(i) = 'italic');
            end;
          end
          else if s = 'firstweekday' then
            Conf.FirstWDay := SInt(GetArg(1))
          else if s = 'weeknumber' then
            Conf.WeekNumber := GetArg(1) = 'on'
          else if s = 'yearday' then
            Conf.YearDay := GetArg(1) = 'on'
          else if s = 'outerdays' then
            Conf.OuterDays := GetArg(1) = 'on';
        end;
      finally
        Free;
      end;
  except
    on E: EIOError do ;
  end;
end;

end.
