unit holiday_jp;

interface

function IsHoliday(Year, Month, Day: Integer): Boolean;

implementation

uses NDate;

function IsHolidaySub(Year, Month, Day: Integer): Boolean;
var
  wd: Integer;
begin
  Result := False;
  wd := WeekDay(Year, Month, Day);
  case Month of
    1: Result := (Day = 1) or ((Day >= 8) and (Day <= 14) and (wd = 0));
    2: Result := Day = 11;
    3: Result := Day = Trunc(20.8431+0.242194*(Year-1980)-Trunc((Year-1980)/4));
    4: Result := Day = 29;
    5: Result := (Day = 3) or (Day = 4) or (Day = 5);
    7: Result := (Day >= 15) and (Day <= 21) and (wd = 0);
    9: Result := ((Day >= 15) and (Day <= 21) and (wd = 0)) or
        (Day = Trunc(23.2488+0.242194*(Year-1980)-Trunc((Year-1980)/4)));
    10: Result := (Day >= 8) and (Day <= 14) and (wd = 0);
    11: Result := (Day = 3) or (Day = 23);
    12: Result := Day = 23;
  end;
end;

function IsHoliday(Year, Month, Day: Integer): Boolean;
var
  y, m, d: Integer;
  py, pm, pd: Integer;
  ny, nm, nd: Integer;
begin
  Result := IsHolidaySub(Year, Month, Day);

  // check compensatory holiday
  y := Year;
  m := Month;
  d := Day;
  if not Result then
    while True do
    begin
      PrevDate(y, m, d, py, pm, pd);
      if IsHolidaySub(py, pm, pd) then
      begin
        if WeekDay(py, pm, pd) = 6 then
        begin
          Result := True;
          Break;
        end
      end else
        Break;
      y := py;
      m := pm;
      d := pd;
    end;

  // check "kokumin no kyujitsu"
  if not Result and (WeekDay(Year, Month, Day) <> 6) then
  begin
    PrevDate(Year, Month, Day, py, pm, pd);
    NextDate(Year, Month, Day, ny, nm, nd);
    Result := IsHolidaySub(py, pm, pd) and IsHolidaySub(ny, nm, nd);
  end;
end;

end.
